#ifndef PCF_H

#define	PCF_FILE_VERSION	(('p'<<24)|('c'<<16)|('f'<<8)|1)

#define	PCF_DEFAULT_FORMAT	0x00000000
#define	PCF_COMPRESSED_METRICS	0x00000100
#define	PCF_ACCEL_W_INKBOUNDS	0x00000100
#define	PCF_INKBOUNDS		0x00000200

typedef struct {
	Mask label;
	int format;	/* format of data */
	int size;	/* length in bytes for this table */
	int start;	/* byte offset from front of file for this table */
} TableDesc;

typedef struct _pcfTOCWriteFuncs {
	int	 	(* buildTOCFunc)(/*pfont, pCS, label, fmtOrder, pTOC*/);
	int 		(* sizeFunc)(/* pfont, pCS, state, pTables */);
	void		(* writeFunc)(/* file, pfont, label, format */);
} pcfTOCWriteFuncsRec, *pcfTOCWriteFuncsPtr;

typedef struct _pcfTOCReadFuncs {
	pointer	 	(* initFunc)(/* pfont, pCS, TablesMask, params */);
	Bool 		(* selectFunc)(/* pfont, pCS, state, pTables,ptoc,prfunc */);
	void		(* finalizeFunc)(/* state */);
} pcfTOCReadFuncsRec, *pcfTOCReadFuncsPtr;

#define	PCF_COMPAT_PUBLIC_REL	1
#define	PCF_LAST_RELEASE	PCF_COMPAT_PUBLIC_REL
#define	PCF_LATEST_AND_GREATEST	32000
extern	unsigned	pcfCompatLevel;
extern	Bool		pcfCompatIdentical;
extern	Bool		pcfSuppressOSTables;

extern Bool pcfBuildTOC(/*pfont, pCS, label, fmtOrder, pTOC*/);
extern void pcfWriteTable(/* file, pfont, label, format */);

#ifdef OS_HAS_WRITERS
extern Bool pcfOSBuildTOC(/*pfont, pCS, label, fmtOrder, pTOC*/);
extern void pcfOSWriteTable(/* file, pfont, label, format */);
#endif

extern pointer	pcfInitTOC(/* pfont, pCS, TablesMask, params */);
extern Bool	pcfSelect(/* pfont, pCS, state, pTables, ptoc, prfunc */);
extern void 	pcfFinalizeTOC(/* state */);

#ifdef OS_HAS_READERS
extern pointer	pcfOSInitTOC(/* pfont, pCS, TablesMask, params */);
extern Bool	pcfOSSelect(/* pfont, pCS, state, pTables, ptoc, prfunc */);
extern void 	pcfOSFinalizeTOC(/* state */);
#endif

extern	Mask	pcfReadFont(/* file, ppFont, ppCS, tables, params */);
#endif /* PCF_H */
