#ifndef CAL_H
#define CAL_H 1

#define	CAL_NAME		"tablet"
#define	CAL_TYPE		"TABLET"
#define	CAL_NUM_BUTTONS	4
#define	CAL_ALL_BUTTONS	0x0f

#define	CAL_NUM_VALUATORS	6
#define	CAL_NUM_AXES		2
#define	CAL_VALUATOR_MIN	0
#define	CAL_VALUATOR_MAX	7000
#define	CAL_MAX_PRESSURE	127
#define	CAL_VALUATOR_RESOLUTION		1000
#define	CAL_VALUATOR_MIN_RESOLUTION	1000
#define	CAL_VALUATOR_MAX_RESOLUTION	1000
#define	CAL_ALL_VALUATORS	0x3

#define	CAL_PHASE_BIT		0x80
#define	CAL_NOT_SYNCHED	-1
#define	CAL_FLAGS		0
#define	CAL_HIGH_X		1
#define	CAL_LOW_X		2
#define	CAL_HIGH_Y		3
#define	CAL_MID_Y		4
#define	CAL_LOW_Y		5
#define	CAL_X_TILT		6
#define	CAL_Y_TILT		7
#define	CAL_PRESSURE		8
#define	CAL_HEIGHT		9

#ifdef _KERNEL
typedef struct cal_state {
	idevInfo		info;

	idevValuatorDesc	vdesc[CAL_NUM_VALUATORS];
	idevTransform		vtrans[CAL_NUM_VALUATORS];

	unsigned char		vactive;
	int			vstate[CAL_NUM_VALUATORS];

	unsigned char		bactive;
	unsigned char		bstate;

	int			state;
	idevValuatorState	vals;

	char			flags;
	char			btn_pressure;
	short			left;
	short			right;
	short			top;
	short			bottom;

	/* Misc. Std. Driver stuff */
	unsigned char initialized;/* true if data structures are set */
				/* and init sequence has been sent to */
				/* device */
	unsigned char ready;	/* true if we've received confirmation */
				/* of the init sequence from the device */
} cal_state_t;

#endif /* _KERNEL */

#endif
