#ifndef	__com_inode__
#define	__com_inode__
/*
 * Common inode support.  Filesystems which share a similar set of
 * semantics and information can also share procedures if they
 * use this structure.
 *
 * $Source: /bvd/att/usr/src/uts/mips/sys/fs/RCS/com_inode.h,v $
 * $Date: 1989/10/10 20:07:41 $
 * $Revision: 3.5 $
 */
#ident	"$Revision: 3.5 $"

/*
 * Common inode information.  For filesystems using this, this structure
 * must be the first element in the private inode date (pointed at by
 * i_fsptr).
 */
struct com_inode {
	long	ci_magic;	/* magic number */
	time_t	ci_atime;	/* time last accessed */
	time_t	ci_mtime;	/* time last modified */
	time_t	ci_ctime;	/* time created or changed */
	ushort	ci_mode;	/* protection mode */
	short	ci_lastlen;	/* last length read */
	daddr_t	ci_lastbn;	/* last logical block read */
};

/* convert inode fs pointer to structure pointer */
#define	com_fsptr(ip)	((struct com_inode *) (ip)->i_fsptr)

#define	COM_MAGIC	0x12345678	/* identifies "com" filesystem */
#define	COM_ROOTINO	((ino_t) 2)	/* XXX should be in fsinfo[] */

/*
 * Size of block device i/o is parameterized here.
 * Currently the system supports 4k i/o.
 */
#define	BLKDEV_IOSHIFT		12
#define	BLKDEV_IOSIZE		(1<<BLKDEV_IOSHIFT)

/* convert a byte offset into an offset into a logical block for a block dev */
#define	BLKDEV_OFF(off)		((off) & (BLKDEV_IOSIZE - 1))

/* convert a byte offset into a block device logical block # */
#define	BLKDEV_LBN(off)		((off) >> BLKDEV_IOSHIFT)

/* number of bb's per block device block */
#define	BLKDEV_BB		BTOBB(BLKDEV_IOSIZE)

/* convert logical block dev block to physical blocks (== bb's) */
#define	BLKDEV_LTOP(bn)		((bn) * BLKDEV_BB)

#ifdef	_KERNEL
extern	short	com_fstyp;
# include "sys/sema.h"
extern	sema_t	ancestorlock;		/* notancestor() serialization */
#endif

#endif	/* __com_inode__ */
