/**************************************************************************
 *									  *
 * 		 Copyright (C) 1986, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef __SYS_LOCK_H__
#define __SYS_LOCK_H__

#ifdef __cplusplus
extern "C" {
#endif

#ident	"$Revision: 3.10 $"
/*
 * flags for locking procs and texts and pages
 */
#define	UNLOCK	 0
#define	PROCLOCK 1
#define	TXTLOCK	 2
#define	DATLOCK	 4
#define	PGLOCK	 8

/*
 * Structure for page locking map
 */
struct lckmap {
	struct lckmap	*m_next;
	long		m_addr;
	long		m_size;
	long		m_cnt;
};

#ifndef _KERNEL
extern int 	plock (int);
#endif

#ifdef _KERNEL
int punlock(void);
int lockpages(struct proc *, caddr_t, int);
int unlockpages(struct proc *, caddr_t, int, int);
void lockmapdetach(struct pregion *, struct user *);
#endif

#ifdef __cplusplus
}
#endif

#endif /* !__SYS_LOCK_H__ */

