#ifndef __SYS_POLL__
#define __SYS_POLL__
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*
 * Copyright 1989 Silicon Graphics, Inc.  All rights reserved.
 */
#ident "$Revision: 1.12 $"

/*
 * Structure of file descriptor/event pairs supplied in
 * the poll arrays.
 */
struct pollfd {
	int fd;				/* file desc to poll */
	short events;			/* events of interest on fd */
	short revents;			/* events that occurred on fd */
};

/*
 * Testable select events 
 */
#define POLLIN		01		/* fd is readable */
#define POLLPRI		02		/* priority info at fd */
#define	POLLOUT		04		/* fd is writeable (won't block) */

/*
 * Non-testable poll events (may not be specified in events field,
 * but may be returned in revents field).
 */
#define POLLERR		010		/* fd has error condition */
#define POLLHUP		020		/* fd has been hung up on */
#define POLLNVAL	040		/* invalid pollfd entry */

#ifdef	_KERNEL
/*
 * Number of pollfd entries to read in at a time in poll.
 * The larger the value the better the performance, up to the
 * maximum number of open files allowed.  Large numbers will
 * use excessive amounts of kernel stack space.
 */
#define NPOLLFILE	20

/*
 * "Queue" of processes waiting for poll events to occur on a device.
 * Only the first process is remembered via pq_proc.  The second thru
 * Nth sleep on a global event, and must race upon wakeup to recheck
 * poll conditions via FS_POLL.
 */
struct pollqueue {
	struct proc	*pq_proc;	/* first process to poll */
	int		pq_coll;	/* whether there was a collision */
};

#ifdef SVR3

void	pollqueue(struct pollqueue *, struct proc *);
void	pollwakeup(struct pollqueue *);

#else  /* SVR0 */

void	pollqueue();
void	pollwakeup();

#endif /* SVR0 */
#endif /* _KERNEL */
#endif /* __SYS_POLL__ */
