#ifndef __SYS_PROFIL_H__
#define __SYS_PROFIL_H__		/* Prevent nested includes */

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident	"$Revision: 1.3 $"

struct prof {
	void	*pr_base;	/* buffer base */
	unsigned pr_size;	/* buffer size */
	unsigned pr_off;	/* pc offset */
	unsigned pr_scale;	/* pc scaling */
};

#define PROF_USHORT	0x0001	/* treat pr_base as unsigned short array */

#ifdef _KERNEL
extern int nprofile;
#else /* !_KERNEL */
/*
 * Maximum number of prof structures that can be passed as an argument to
 * the sprofil(2) system call. This can be changed at sysgen time by
 * changing the parameter NPROFIL in the file /usr/sysgen/master.d/kernel.
 */
#define PROFIL_MAX	100

extern void profil(short *, int, int, int);
extern int sprofil(struct prof *, int, struct timeval *tvp, unsigned int flags);
#endif /* _KERNEL */

#endif /* __SYS_PROFIL_H__ */
