#ifndef __SYS_RUNQ_H__
#define __SYS_RUNQ_H__

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1986, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident "$Revision: 3.9 $"

/*
 * Structure for the run q
 */

struct runq {
	struct proc 	*qp;		/* normal run queue */
	struct proc 	*qe;
	struct proc	*mqp;		/* mustrun run queue */
	struct proc	*mqe;
#ifdef KMODE
	struct proc	*qkmp;		/* kmode run queue */
	struct proc	*qkme;
#endif /* KMODE */
	lock_t		lock;
#ifdef KMODE
	short		kmode;
	int		kmowner;
	int		lastpc;
	struct proc	*proc;
#endif /* KMODE */
};

extern struct runq	runq;

#ifdef KMODE
#define	KM_ON		1
#define	KM_ONACQ	2
#define	KM_ONQACQ	3
#define	KM_DISPACQ	4
#define	KM_ONHELD	5
#define	KM_OFF		6
#define	KM_OFFSTILL	7
#define	KM_GRABACQ	8
#define	KM_RESTORE	9
#define	KM_RELEASE	10
#endif /* KMODE */

typedef struct lowestpri {
	uint	cpu;
	uint	pri;
} lowestpri_t;
extern lowestpri_t lowestpri;


#endif /* __SYS_RUNQ_H__ */
