#ifndef __UCONTEXT_H__
#define __UCONTEXT_H__

#pragma once

/*
 * This header is based on preliminary information from the draft
 * MIPS ABI, and is subject to change.
 */

typedef struct gregset {
    unsigned int gp_regs[32];
    unsigned int gp_mdlo;
    unsigned int gp_mdhi;
    unsigned int gp_cause;
    unsigned int gp_pc;
} gregset_t;

typedef struct fpregst {
    union {
	double		fp_dregs[16];
	float		fp_fregs[32];
	unsigned int	fp_regs[32];
    } fp_r;
    unsigned int fp_csr;
} fpregset_t;

typedef struct {
    gregset_t  gpregs;
    fpregset_t fpregs;
} mcontext_t;

typedef struct ucontext {
    unsigned long	uc_flags;
    struct ucontext	*uc_link;
    sigset_t		uc_sigmask;
    stack_t		uc_stack;
    mcontext_t		uc_mcontext;
    long		uc_filler;
} ;

#endif
