#ifndef WACOM_H
#define WACOM_H 1

#define	WACOM_NAME		"wacom"
#define	WACOM_TYPE		"TABLET"
#define	WACOM_NUM_BUTTONS	1
#define	WACOM_ALL_BUTTONS	0x1

#define	WACOM_NUM_VALUATORS	3
#define	WACOM_X_VALUATOR_MIN	0
#define	WACOM_X_VALUATOR_MAX	4600
#define	WACOM_Y_VALUATOR_MIN	0
#define	WACOM_Y_VALUATOR_MAX	3000
#define	WACOM_PRESSURE_MIN	0
#define	WACOM_PRESSURE_MAX	64
#define	WACOM_VALUATOR_RESOLUTION	200
#define	WACOM_VALUATOR_MIN_RESOLUTION	200
#define	WACOM_VALUATOR_MAX_RESOLUTION	200
#define	WACOM_ALL_VALUATORS	0x07

#define	WACOM_FLAG_BIT		0x80
#define	WACOM_NOT_SYNCHED	-1
#define	WACOM_FLAGS		0
#define	WACOM_HIGH_X		1
#define	WACOM_LOW_X		2
#define	WACOM_HIGH_Y		3
#define	WACOM_MID_Y		4
#define	WACOM_LOW_Y		5
#define	WACOM_PRESSURE		6

#ifdef _KERNEL
typedef struct wac_state {
	idevInfo		info;

	int			state;
	idevValuatorState	vals;

	idevValuatorDesc	vdesc[WACOM_NUM_VALUATORS];
	idevTransform		vtrans[WACOM_NUM_VALUATORS];
	int			vstate[WACOM_NUM_VALUATORS];
	unsigned char		vactive;

	unsigned char		bactive;
	unsigned char		bstate;

	char			inside;
	int			xsign;
	int			ysign;

	unsigned char		btn_pressure;
	unsigned char		pad0;
	unsigned short		pad1;

	/* Misc. Std. Driver stuff */
	unsigned char initialized;/* true if data structures are set */
				/* and init sequence has been sent to */
				/* device */
	unsigned char ready;	/* true if we've received confirmation */
				/* of the init sequence from the device */
} wac_state_t;

#endif /* _KERNEL */

#endif
