#ifndef XMIDI_H
#define XMIDI_H 1

#define	XMIDI_NAME		"XMIDI"
#define	XMIDI_TYPE		"XMIDI"
#define	XMIDI_NUM_BUTTONS	128

#define	XMIDI_NUM_VALUATORS		219
#define	XMIDI_VALUATOR_MIN		0
#define	XMIDI_VALUATOR_MAX		127
#define	XMIDI_VALUATOR_RESOLUTION	1
#define	XMIDI_VALUATOR_MIN_RESOLUTION	1
#define	XMIDI_VALUATOR_MAX_RESOLUTION	1

#define	XMIDI_FLAGS			0

/* midi channels.  these values are or'd together and sent to the driver
 * with an idevOtherControl ioctl command.  
 */

#define XMIDI_CHAN_CMD                  "SETCHANNEL"
#define XMIDI_CHAN1                     0x1
#define XMIDI_CHAN2                     0x2
#define XMIDI_CHAN3                     0x4
#define XMIDI_CHAN4                     0x8
#define XMIDI_CHAN5                     0x10
#define XMIDI_CHAN6                     0x20
#define XMIDI_CHAN7                     0x40
#define XMIDI_CHAN8                     0x80
#define XMIDI_CHAN9                     0x100
#define XMIDI_CHAN10                    0x200
#define XMIDI_CHAN11                    0x400
#define XMIDI_CHAN12                    0x800
#define XMIDI_CHAN13                    0x1000
#define XMIDI_CHAN14                    0x2000
#define XMIDI_CHAN15                    0x4000
#define XMIDI_CHAN16                    0x8000
#define XMIDI_ALL                       0xffff

#ifdef _KERNEL
typedef struct xmidi_state {
	idevInfo		info;

	idevValuatorDesc	vdesc[XMIDI_NUM_VALUATORS];
	idevTransform		vtrans[XMIDI_NUM_VALUATORS];

	unsigned char		vactive[idevSize(XMIDI_NUM_VALUATORS)];
	int			vstate[XMIDI_NUM_VALUATORS];

	unsigned char		bactive[idevSize(XMIDI_NUM_BUTTONS)];
	unsigned char		bstate[idevSize(XMIDI_NUM_BUTTONS)];

	int			channel_mask;
	int			msb[32];

	/* Misc. Std. Driver stuff */
	unsigned char initialized;/* true if data structures are set */
				/* and init sequence has been sent to */
				/* device */
	unsigned char ready1;	/* true if we've received confirmation */
				/* of the init sequence from the device */
	unsigned char errorCount;/* count of bad messages for recovery */
} xmidi_state_t;

#endif /* _KERNEL */

#endif
