#ifndef __TIME_H__
#define __TIME_H__
#ifdef __cplusplus
extern "C" {
#endif
/* Copyright (C) 1989 Silicon Graphics, Inc. All rights reserved.  */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* #ident "$Revision: 1.18 $" */

/* ANSI C Notes:
 *
 * - THE IDENTIFIERS APPEARING OUTSIDE OF #ifdef __EXTENSIONS__ IN THIS
 *   standard header ARE SPECIFIED BY ANSI!  CONFORMANCE WILL BE ALTERED
 *   IF ANY NEW IDENTIFIERS ARE ADDED TO THIS AREA UNLESS THEY ARE IN ANSI's
 *   RESERVED NAMESPACE. (i.e., unless they are prefixed by __[a-z] or
 *   _[A-Z].  For external objects, identifiers with the prefix _[a-z] 
 *   are also reserved.)
 */

#ifndef NULL
#define NULL	0
#endif

/* Number per second of the value returned by clock(3C). */
#define CLOCKS_PER_SEC	1000000


#ifndef _CLOCK_T_
#define _CLOCK_T_
typedef long	clock_t;	/* Type returned by clock(3C) */
#endif /* !_CLOCK_T_ */

#ifndef _TIME_T_
#define _TIME_T_
typedef	long	time_t;
#endif /* !_TIME_T_ */

#ifndef _SIZE_T_
#define _SIZE_T_
typedef unsigned size_t;
#endif /* !_SIZE_T_ */

struct	tm {	/* see ctime(3) */
	int	tm_sec;		/* seconds after the min [0,60] */
	int	tm_min;		/* minutes after the hour [0,59] */
	int	tm_hour;	/* hours since midnight [0,23] */
	int	tm_mday;	/* day of the month [1,31] */
	int	tm_mon;		/* months since Jan [0,11] */
	int	tm_year;	/* years since 1900 */
	int	tm_wday;	/* days since Sunday [0,6] */
	int	tm_yday;	/* days since Jan 1 [0,365] */
	int	tm_isdst;	/* Daylight Savings Time flag -
				 * >0 == DST, 0 == !DST, <0 == unknown */
};

extern clock_t	clock(void);
extern time_t	time(time_t *);
extern time_t	mktime(struct tm *);
extern double	difftime(time_t /* later */, time_t /* earlier */);
extern char *	asctime(const struct tm *);
extern char *	ctime(const time_t *);
extern struct tm * gmtime(const time_t *);
extern struct tm * localtime(const time_t *);
extern size_t	strftime (char *, size_t, const char *, const struct tm *);
extern int	_cftime(char *, char *, time_t *);
extern int	_ascftime(char *, char *, struct tm *);
extern void	_tzset(void);
extern int	_isleapyear(int);
extern char *	_tzname[];
extern long	_timezone;
extern long	_altzone;
extern int	_daylight;

#if (defined(__EXTENSIONS__) || defined(_POSIX_SOURCE))
/* CLK_TCK is defined here (in addition to limits.h) because POSIX
 * requires it.  Please do not remove.
 */
#ifndef CLK_TCK
#define	CLK_TCK		100		/* # of clock ticks per second */
#endif

#define tzname		_tzname
#define timezone	_timezone
#define altzone		_altzone
#define daylight	_daylight

extern int	cftime(char *, char *, time_t *);
extern int	ascftime(char *, char *, struct tm *);
extern void	tzset(void);
#endif /* __EXTENSIONS__ || _POSIX_SOURCE */

#ifdef __cplusplus
}
#endif
#endif /* !__TIME_H__ */
